#ifndef _OTREE_H
#define _OTREE_H

#include "util.h"

void palotree_tumat(int nele, int maxn, double ogap, double** distmatrix, vector<Onode> & result, ostream & dendout, int opt);
void palotree(int nele, int maxn, double ogap, double** distmatrix, vector<Onode> & result, ostream & dendout);
void pmlotree(int nele, int maxn, double ogap, double** distmatrix, vector<Onode> & result);
void cutotree(double cutgap, const vector<Onode> & otree, double thresh, vector<pair<int, intset> > & clusters);
double find_closest_pair_pmlotree(int n, double** distmatrix, int* ip, int* jp, const vector<intvec> & omat, const vector<intvec> & mmat);
double find_closest_pair_palotree(int n, double** distmatrix, int* ip, int* jp, const vector<intvec> & omat, vector<intvec> & mmat);
int CalcOverlap(int oij, int oi, int oj, const intset & cij, const intset & ci, const intset & cj, const intset & c);
inline void OutOtree(int id, vector<Onode> & otree, ostream & out);
void AddClus(int id, const vector<Onode> & otree, intset & membs);

inline void OutOtree(int id, vector<Onode> & otree, ostream & out) {
  out << id << '\t' << otree[id].left << '\t' << otree[id].right << '\t' << otree[id].distance << '\t' << otree[id].upperb << '\t' << otree[id].lowerb << '\t' << otree[id].touse << '\t' << otree[id].size << endl;
}

#endif // _OTREE_H
