#include "util.h"

void PrintDistmat(ostream & out, double ** const & distmat, int nc, int linkage)
{
  int i, j;
  out << "distmat" << endl;
  for (i = 0; i < nc; i++) {
    for (j = 0; j < i; j++) {
      out << distmat[i][j] << '\t';
    }
    if (linkage == 0) {
      out << distmat[i][i] << endl;
    } else {
      out << "N/A" << endl;
    }
  }
}

void PrintDistmatCluster(ostream & out, double ** const & distmat, int nc, int linkage, const vector<Onode> & result, const intvec & clusterid)
{
  int i, j;
  out << "distmat" << endl;
  for (i = 0; i < nc; i++) {
    const Onode & ni = result[clusterid[i]];
    out << i << "\tleft\t" << ni.left << "\tright\t" << ni.right << "\tdistance\t" << ni.distance << "\tsize\t" << ni.size << '\t';
    for (j = 0; j < i; j++) {
      out << distmat[i][j] << '\t';
    }
    if (linkage == 0) {
      out << distmat[i][i] << endl;
    } else {
      out << "N/A" << endl;
    }
  }
}

void PrintCluster(ostream & out, int nc, const vector<Onode> & result, const intvec & clusterid)
{
  int i;
  out << "cluster" << endl;
  for (i = 0; i < nc; i++) {
    const Onode & ni = result[clusterid[i]];
    out << i << "\tleft\t" << ni.left << "\tright\t" << ni.right << "\tdistance\t" << ni.distance << "\tsize\t" << ni.size << endl;
  }
}

void PrintVecmat(ostream & out, const vector<intvec> & mat, int nc)
{
  int i;
  for (i = 0; i < nc; i++) {
    Mylib::PrintJoin(out, mat[i], "\t");
    out << endl;
  }
}

void PrintVecmat(ostream & out, const vector<dblvec> & mat, int nc)
{
  int i;
  for (i = 0; i < nc; i++) {
    Mylib::PrintJoin(out, mat[i], "\t");
    out << endl;
  }
}
