#ifndef __UTIL_H
#define __UTIL_H

#include <iostream>
#include <vector>
#include <set>
#include <cassert>
#include <MyClib/Util/io.h>
using namespace std;

typedef vector<int> intvec;
typedef vector<double> dblvec;
typedef set<int> intset;

const double g_dlarge = 1e12;
const int g_ilarge = 1000000000;
const int g_bufsize = 100000;
const int g_maxiter = 100000;
const int g_debug = 0;

typedef struct {
  int left, right, size;
  double distance, upperb, lowerb, touse;
  intset membs; // TODO: may remove to save memory
} Onode;

void PrintDistmat(ostream & out, double ** const & distmat, int nc, int linkage);
void PrintDistmatCluster(ostream & out, double ** const & distmat, int nc, int linkage, const vector<Onode> & result, const intvec & clusterid);
void PrintCluster(ostream & out, int nc, const vector<Onode> & result, const intvec & clusterid);
void PrintVecmat(ostream & out, const vector<intvec> & mat, int nc);
void PrintVecmat(ostream & out, const vector<dblvec> & mat, int nc);

#endif // __UTIL_H
